# The Following Command Applies To The Native-Code Compilation (ocamlopt)
# .cmi are CoMpiled Interface files
# .cmx are CoMpiled files containing eXtra info for linking and optimization of the clients of the unit
# .o are compiled files with native Object code (they are C files)
rm -f *.cmi *.cmx *.o 
rm -f ./../regstab-2.0.0/*.cmi ./../regstab-2.0.0/*.cmx  ./../regstab-2.0.0/*.o

# The Following Command Applies To The Batch Compilation (ocamlc)
# .cmi are CoMpiled Interface files
# .cmo are CoMpiled Object bytecode files
rm -f *.cmi *.cmo
rm -f ./../regstab-2.0.0/*.cmi ./../regstab-2.0.0/*.cmo ./../regstab-2.0.0/*~

# The Following Command Applies To The Lexer And The Parser
# the .ml files can be generated again by running ./compileParser.sh
rm -f lexer.ml parser.ml

rm -f run runOpt

rm -f *~
