exception Error

type token = 
  | ZERO
  | RPAREN
  | PLUS
  | P
  | ONE
  | NOT
  | LPAREN
  | LEQ
  | INT of (
# 12 "parserAssumptions.mly"
       (int)
# 16 "parserAssumptions.ml"
)
  | EQUAL
  | EOL
  | B
  | AND

and _menhir_env = {
  _menhir_lexer: Lexing.lexbuf -> token;
  _menhir_lexbuf: Lexing.lexbuf;
  mutable _menhir_token: token;
  mutable _menhir_startp: Lexing.position;
  mutable _menhir_endp: Lexing.position;
  mutable _menhir_shifted: int
}

and _menhir_state = 
  | MenhirState62
  | MenhirState59
  | MenhirState56
  | MenhirState52
  | MenhirState49
  | MenhirState45
  | MenhirState43
  | MenhirState42
  | MenhirState31
  | MenhirState28
  | MenhirState15
  | MenhirState14
  | MenhirState13
  | MenhirState11
  | MenhirState7
  | MenhirState6
  | MenhirState3
  | MenhirState0


# 1 "parserAssumptions.mly"
  

(* OCamls imports and others go here *)
open Module_KatExpressions
exception ERROR of string
let errMsg_commutCond = "You inserted an expression that appears to be a commutativity condition but it is malformed. For instructions, exit and type ./runme -help.";;
let errMsg_hoareTriple = "You inserted an expression that appears to be an Hoare triple but it is malformed. For instructions, exit and type ./runme -help.";;

# 62 "parserAssumptions.ml"
let _eRR =
  Error

let rec _menhir_goto_line : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_line -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv337 * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv335 * _menhir_state * 'tv_line) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | EOL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv331 * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv329 * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, l) = _menhir_stack in
            let _v : (
# 23 "parserAssumptions.mly"
      ( ( ((int * (MKE.be * MKE.be)) list) * ((MKE.be * MKE.be) list) ))
# 88 "parserAssumptions.ml"
            ) = 
# 28 "parserAssumptions.mly"
               (l)
# 92 "parserAssumptions.ml"
             in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv327) = _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 23 "parserAssumptions.mly"
      ( ( ((int * (MKE.be * MKE.be)) list) * ((MKE.be * MKE.be) list) ))
# 100 "parserAssumptions.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv325) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 23 "parserAssumptions.mly"
      ( ( ((int * (MKE.be * MKE.be)) list) * ((MKE.be * MKE.be) list) ))
# 108 "parserAssumptions.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv323) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_1 : (
# 23 "parserAssumptions.mly"
      ( ( ((int * (MKE.be * MKE.be)) list) * ((MKE.be * MKE.be) list) ))
# 116 "parserAssumptions.ml"
            )) = _v in
            (Obj.magic _1 : 'freshtv324)) : 'freshtv326)) : 'freshtv328)) : 'freshtv330)) : 'freshtv332)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv333 * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv334)) : 'freshtv336)) : 'freshtv338)
    | MenhirState59 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv341 * _menhir_state * 'tv_axiomLeq) * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv339 * _menhir_state * 'tv_axiomLeq) * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, a), _, ls) = _menhir_stack in
        let _v : 'tv_line = 
# 32 "parserAssumptions.mly"
                              ( match ls with (ls1,ls2) -> (ls1,a::ls2) )
# 135 "parserAssumptions.ml"
         in
        _menhir_goto_line _menhir_env _menhir_stack _menhir_s _v) : 'freshtv340)) : 'freshtv342)
    | MenhirState62 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv345 * _menhir_state * 'tv_axiomEq) * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv343 * _menhir_state * 'tv_axiomEq) * _menhir_state * 'tv_line) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, a), _, ls) = _menhir_stack in
        let _v : 'tv_line = 
# 31 "parserAssumptions.mly"
                             ( match ls with (ls1,ls2) -> (a::ls1,ls2) )
# 147 "parserAssumptions.ml"
         in
        _menhir_goto_line _menhir_env _menhir_stack _menhir_s _v) : 'freshtv344)) : 'freshtv346)
    | _ ->
        _menhir_fail ()

and _menhir_goto_axiomEq : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_axiomEq -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv321 * _menhir_state * 'tv_axiomEq) = Obj.magic _menhir_stack in
    ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
    let _tok = _menhir_env._menhir_token in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv319 * _menhir_state * 'tv_axiomEq) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | AND ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv313 * _menhir_state * 'tv_axiomEq) = Obj.magic _menhir_stack in
        ((let _tok = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv311 * _menhir_state * 'tv_axiomEq) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | LPAREN ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | NOT ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | ONE ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | P ->
            _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState62
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState62) : 'freshtv312)) : 'freshtv314)
    | EOL ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv315 * _menhir_state * 'tv_axiomEq) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, a) = _menhir_stack in
        let _v : 'tv_line = 
# 33 "parserAssumptions.mly"
            (([a],[]))
# 195 "parserAssumptions.ml"
         in
        _menhir_goto_line _menhir_env _menhir_stack _menhir_s _v) : 'freshtv316)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv317 * _menhir_state * 'tv_axiomEq) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv318)) : 'freshtv320)) : 'freshtv322)

and _menhir_fail : unit -> 'a =
  fun () ->
    Printf.fprintf Pervasives.stderr "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

and _menhir_goto_plus : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_plus -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState13 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv305 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_plus) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv303 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let (ts : 'tv_plus) = _v in
        ((let (_menhir_stack, _menhir_s, t) = _menhir_stack in
        let _v : 'tv_plus = 
# 52 "parserAssumptions.mly"
                          (if t=MKE.Zero then ts else t::ts)
# 227 "parserAssumptions.ml"
         in
        _menhir_goto_plus _menhir_env _menhir_stack _menhir_s _v) : 'freshtv304)) : 'freshtv306)
    | MenhirState11 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv309 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_plus) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv307 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let (ts : 'tv_plus) = _v in
        ((let (_menhir_stack, _menhir_s, t) = _menhir_stack in
        let _v : 'tv_bexp = 
# 48 "parserAssumptions.mly"
                          (if t=MKE.Zero then MKE.buildDisj ts else MKE.buildDisj (t::ts))
# 243 "parserAssumptions.ml"
         in
        _menhir_goto_bexp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv308)) : 'freshtv310)
    | _ ->
        _menhir_fail ()

and _menhir_goto_bexp : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_bexp -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState7 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv149 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv147 * _menhir_state) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv143 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _ = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv141 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let ((_menhir_stack, _menhir_s), _, e) = _menhir_stack in
            let _v : 'tv_symb = 
# 68 "parserAssumptions.mly"
                         (e)
# 272 "parserAssumptions.ml"
             in
            _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv142)) : 'freshtv144)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv145 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv146)) : 'freshtv148)) : 'freshtv150)
    | MenhirState6 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv159 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv157 * _menhir_state) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv153 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _ = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv151 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let ((_menhir_stack, _menhir_s), _, e) = _menhir_stack in
            let _v : 'tv_symb = 
# 69 "parserAssumptions.mly"
                               (MKE.buildNeg e)
# 301 "parserAssumptions.ml"
             in
            _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv152)) : 'freshtv154)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv155 * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv156)) : 'freshtv158)) : 'freshtv160)
    | MenhirState28 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv163 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 316 "parserAssumptions.ml"
        )) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 320 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv161 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 326 "parserAssumptions.ml"
        )) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 330 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (((((_menhir_stack, _menhir_s), i), _), j), _, b2) = _menhir_stack in
        let _v : 'tv_axiomEq = 
# 38 "parserAssumptions.mly"
                                          (if (not (i=j)) then raise (ERROR errMsg_hoareTriple) else (i,(MKE.One,b2)))
# 336 "parserAssumptions.ml"
         in
        _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv162)) : 'freshtv164)
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv183 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 344 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv181 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 352 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | EQUAL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv177 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 361 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv175 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 368 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState31
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState31
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState31
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState31
            | P ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv173 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 385 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (_menhir_s : _menhir_state) = MenhirState31 in
                ((let _menhir_stack = (_menhir_stack, _menhir_s) in
                let _tok = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv171 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 394 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state) = _menhir_stack in
                let (_tok : token) = _tok in
                ((match _tok with
                | INT _v ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv167 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 403 "parserAssumptions.ml"
                    )) * _menhir_state * 'tv_bexp) * _menhir_state) = Obj.magic _menhir_stack in
                    let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 408 "parserAssumptions.ml"
                    )) = _v in
                    ((let _ = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv165 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 415 "parserAssumptions.ml"
                    )) * _menhir_state * 'tv_bexp) * _menhir_state) = Obj.magic _menhir_stack in
                    let (j : (
# 12 "parserAssumptions.mly"
       (int)
# 420 "parserAssumptions.ml"
                    )) = _v in
                    ((let ((((_menhir_stack, _menhir_s), i), _, b2), _) = _menhir_stack in
                    let _v : 'tv_axiomEq = 
# 40 "parserAssumptions.mly"
                                          (if (not (i=j)) then raise (ERROR errMsg_hoareTriple) else (i,(MKE.One,b2)))
# 426 "parserAssumptions.ml"
                     in
                    _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv166)) : 'freshtv168)
                | _ ->
                    assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                    _menhir_env._menhir_shifted <- (-1);
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv169 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 436 "parserAssumptions.ml"
                    )) * _menhir_state * 'tv_bexp) * _menhir_state) = Obj.magic _menhir_stack in
                    ((let (_menhir_stack, _menhir_s) = _menhir_stack in
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv170)) : 'freshtv172)) : 'freshtv174)
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState31
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState31) : 'freshtv176)) : 'freshtv178)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv179 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 453 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv180)) : 'freshtv182)) : 'freshtv184)
    | MenhirState31 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv199 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 462 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv197 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 470 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | P ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv193 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 479 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv191 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 486 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | INT _v ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv187 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 495 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 500 "parserAssumptions.ml"
                )) = _v in
                ((let _ = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv185 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 507 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (j : (
# 12 "parserAssumptions.mly"
       (int)
# 512 "parserAssumptions.ml"
                )) = _v in
                ((let ((((_menhir_stack, _menhir_s), i), _, b1), _, b2) = _menhir_stack in
                let _v : 'tv_axiomEq = 
# 41 "parserAssumptions.mly"
                                                    (if (not (i=j) || not (b1=b2)) then raise (ERROR errMsg_commutCond) else (i,(b1,b1)))
# 518 "parserAssumptions.ml"
                 in
                _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv186)) : 'freshtv188)
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv189 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 528 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv190)) : 'freshtv192)) : 'freshtv194)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv195 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 539 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv196)) : 'freshtv198)) : 'freshtv200)
    | MenhirState62 | MenhirState59 | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv233 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv231 * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | LEQ ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv203 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv201 * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState56
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState56
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState56
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState56
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState56
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState56) : 'freshtv202)) : 'freshtv204)
        | P ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv227 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv225 * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | INT _v ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv221 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 588 "parserAssumptions.ml"
                )) = _v in
                ((let _menhir_stack = (_menhir_stack, _v) in
                let _tok = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv219 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 596 "parserAssumptions.ml"
                )) = _menhir_stack in
                let (_tok : token) = _tok in
                ((match _tok with
                | B ->
                    _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState42
                | EQUAL ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ('freshtv217 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 607 "parserAssumptions.ml"
                    )) = Obj.magic _menhir_stack in
                    let (_menhir_s : _menhir_state) = MenhirState42 in
                    ((let _menhir_stack = (_menhir_stack, _menhir_s) in
                    let _tok = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : (('freshtv215 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 616 "parserAssumptions.ml"
                    )) * _menhir_state) = _menhir_stack in
                    let (_tok : token) = _tok in
                    ((match _tok with
                    | B ->
                        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState43
                    | LPAREN ->
                        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState43
                    | NOT ->
                        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState43
                    | ONE ->
                        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState43
                    | P ->
                        let (_menhir_env : _menhir_env) = _menhir_env in
                        let (_menhir_stack : (('freshtv213 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 633 "parserAssumptions.ml"
                        )) * _menhir_state) = Obj.magic _menhir_stack in
                        let (_menhir_s : _menhir_state) = MenhirState43 in
                        ((let _menhir_stack = (_menhir_stack, _menhir_s) in
                        let _tok = _menhir_discard _menhir_env in
                        let (_menhir_env : _menhir_env) = _menhir_env in
                        let (_menhir_stack : ((('freshtv211 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 642 "parserAssumptions.ml"
                        )) * _menhir_state) * _menhir_state) = _menhir_stack in
                        let (_tok : token) = _tok in
                        ((match _tok with
                        | INT _v ->
                            let (_menhir_env : _menhir_env) = _menhir_env in
                            let (_menhir_stack : ((('freshtv207 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 651 "parserAssumptions.ml"
                            )) * _menhir_state) * _menhir_state) = Obj.magic _menhir_stack in
                            let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 656 "parserAssumptions.ml"
                            )) = _v in
                            ((let _menhir_stack = (_menhir_stack, _v) in
                            let _tok = _menhir_discard _menhir_env in
                            let (_menhir_env : _menhir_env) = _menhir_env in
                            let (_menhir_stack : (((('freshtv205 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 664 "parserAssumptions.ml"
                            )) * _menhir_state) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 668 "parserAssumptions.ml"
                            )) = _menhir_stack in
                            let (_tok : token) = _tok in
                            ((match _tok with
                            | B ->
                                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState45
                            | LPAREN ->
                                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState45
                            | NOT ->
                                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState45
                            | ONE ->
                                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState45
                            | ZERO ->
                                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState45
                            | _ ->
                                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                                _menhir_env._menhir_shifted <- (-1);
                                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState45) : 'freshtv206)) : 'freshtv208)
                        | _ ->
                            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                            _menhir_env._menhir_shifted <- (-1);
                            let (_menhir_env : _menhir_env) = _menhir_env in
                            let (_menhir_stack : ((('freshtv209 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 693 "parserAssumptions.ml"
                            )) * _menhir_state) * _menhir_state) = Obj.magic _menhir_stack in
                            ((let (_menhir_stack, _menhir_s) = _menhir_stack in
                            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv210)) : 'freshtv212)) : 'freshtv214)
                    | ZERO ->
                        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState43
                    | _ ->
                        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                        _menhir_env._menhir_shifted <- (-1);
                        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState43) : 'freshtv216)) : 'freshtv218)
                | LPAREN ->
                    _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState42
                | NOT ->
                    _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState42
                | ONE ->
                    _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState42
                | ZERO ->
                    _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState42
                | _ ->
                    assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                    _menhir_env._menhir_shifted <- (-1);
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState42) : 'freshtv220)) : 'freshtv222)
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv223 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv224)) : 'freshtv226)) : 'freshtv228)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv229 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv230)) : 'freshtv232)) : 'freshtv234)
    | MenhirState45 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((((('freshtv237 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 734 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 738 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((((('freshtv235 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 744 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 748 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let ((((((_menhir_stack, _menhir_s, b1), i), _), _), j), _, b2) = _menhir_stack in
        let _v : 'tv_axiomEq = 
# 42 "parserAssumptions.mly"
                                                     (if (not (i=j) || not (b1=b2)) then raise (ERROR errMsg_commutCond) else (i,(b1,b1)))
# 754 "parserAssumptions.ml"
         in
        _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv236)) : 'freshtv238)
    | MenhirState43 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv253 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 762 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv251 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 770 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | P ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv247 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 779 "parserAssumptions.ml"
            )) * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv245 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 786 "parserAssumptions.ml"
            )) * _menhir_state) * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | INT _v ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv241 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 795 "parserAssumptions.ml"
                )) * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 800 "parserAssumptions.ml"
                )) = _v in
                ((let _menhir_stack = (_menhir_stack, _v) in
                let _tok = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (((('freshtv239 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 808 "parserAssumptions.ml"
                )) * _menhir_state) * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 812 "parserAssumptions.ml"
                )) = _menhir_stack in
                let (_tok : token) = _tok in
                ((match _tok with
                | B ->
                    _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState49
                | LPAREN ->
                    _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState49
                | NOT ->
                    _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState49
                | ONE ->
                    _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState49
                | ZERO ->
                    _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState49
                | _ ->
                    assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                    _menhir_env._menhir_shifted <- (-1);
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState49) : 'freshtv240)) : 'freshtv242)
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv243 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 837 "parserAssumptions.ml"
                )) * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv244)) : 'freshtv246)) : 'freshtv248)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv249 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 848 "parserAssumptions.ml"
            )) * _menhir_state) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv250)) : 'freshtv252)) : 'freshtv254)
    | MenhirState49 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((((('freshtv257 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 857 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 861 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((((('freshtv255 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 867 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 871 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let ((((((_menhir_stack, _menhir_s, b0), i), _), _, b1), j), _, b2) = _menhir_stack in
        let _v : 'tv_axiomEq = 
# 37 "parserAssumptions.mly"
                                                              (if (not (b0=b1) || (not (i=j))) then raise (ERROR errMsg_hoareTriple) else (i,(b0,b2)))
# 877 "parserAssumptions.ml"
         in
        _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv256)) : 'freshtv258)
    | MenhirState42 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv267 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 885 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv265 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 893 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | EQUAL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv261 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 902 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv259 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 909 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState52
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState52
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState52
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState52
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState52
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState52) : 'freshtv260)) : 'freshtv262)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv263 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 934 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv264)) : 'freshtv266)) : 'freshtv268)
    | MenhirState52 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv283 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 943 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv281 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 951 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | P ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv277 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 960 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv275 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 967 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | INT _v ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv271 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 976 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 981 "parserAssumptions.ml"
                )) = _v in
                ((let _ = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv269 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 988 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                let (j : (
# 12 "parserAssumptions.mly"
       (int)
# 993 "parserAssumptions.ml"
                )) = _v in
                ((let ((((_menhir_stack, _menhir_s, b0), i), _, b2), _, b1) = _menhir_stack in
                let _v : 'tv_axiomEq = 
# 39 "parserAssumptions.mly"
                                                              (if (not (b0=b1) || (not (i=j))) then raise (ERROR errMsg_hoareTriple) else (i,(b0,b2)))
# 999 "parserAssumptions.ml"
                 in
                _menhir_goto_axiomEq _menhir_env _menhir_stack _menhir_s _v) : 'freshtv270)) : 'freshtv272)
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv273 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1009 "parserAssumptions.ml"
                )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv274)) : 'freshtv276)) : 'freshtv278)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv279 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1020 "parserAssumptions.ml"
            )) * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv280)) : 'freshtv282)) : 'freshtv284)
    | MenhirState56 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv301 * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv299 * _menhir_state * 'tv_bexp) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, b0), _, b1) = _menhir_stack in
        let _v : 'tv_axiomLeq = 
# 45 "parserAssumptions.mly"
                          ((b1,b0))
# 1033 "parserAssumptions.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv297) = _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_axiomLeq) = _v in
        ((let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv295 * _menhir_state * 'tv_axiomLeq) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv293 * _menhir_state * 'tv_axiomLeq) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | AND ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv287 * _menhir_state * 'tv_axiomLeq) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv285 * _menhir_state * 'tv_axiomLeq) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | P ->
                _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState59
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState59) : 'freshtv286)) : 'freshtv288)
        | EOL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv289 * _menhir_state * 'tv_axiomLeq) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, a) = _menhir_stack in
            let _v : 'tv_line = 
# 34 "parserAssumptions.mly"
             (([],[a]))
# 1079 "parserAssumptions.ml"
             in
            _menhir_goto_line _menhir_env _menhir_stack _menhir_s _v) : 'freshtv290)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv291 * _menhir_state * 'tv_axiomLeq) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv292)) : 'freshtv294)) : 'freshtv296)) : 'freshtv298)) : 'freshtv300)) : 'freshtv302)
    | _ ->
        _menhir_fail ()

and _menhir_goto_concat : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_concat -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState15 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv135 * _menhir_state * 'tv_symb) * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_concat) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv133 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let (fs : 'tv_concat) = _v in
        ((let (_menhir_stack, _menhir_s, s) = _menhir_stack in
        let _v : 'tv_concat = 
# 60 "parserAssumptions.mly"
                     (if s=MKE.Zero then [MKE.Zero] else if s=MKE.One then fs else if fs=[MKE.Zero] then [MKE.Zero] else s::fs)
# 1108 "parserAssumptions.ml"
         in
        _menhir_goto_concat _menhir_env _menhir_stack _menhir_s _v) : 'freshtv134)) : 'freshtv136)
    | MenhirState14 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv139 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_concat) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv137 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let (fs : 'tv_concat) = _v in
        ((let (_menhir_stack, _menhir_s, s) = _menhir_stack in
        let _v : 'tv_term = 
# 56 "parserAssumptions.mly"
                     (if s=MKE.Zero then MKE.Zero else if fs=[MKE.Zero] then MKE.Zero else if fs=[MKE.One] then s else if s=MKE.One then MKE.buildConj fs else MKE.buildConj (s::fs))
# 1124 "parserAssumptions.ml"
         in
        _menhir_goto_term _menhir_env _menhir_stack _menhir_s _v) : 'freshtv138)) : 'freshtv140)
    | _ ->
        _menhir_fail ()

and _menhir_goto_term : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_term -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState62 | MenhirState59 | MenhirState56 | MenhirState52 | MenhirState42 | MenhirState49 | MenhirState43 | MenhirState45 | MenhirState0 | MenhirState31 | MenhirState3 | MenhirState28 | MenhirState6 | MenhirState7 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv119 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv117 * _menhir_state * 'tv_term) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | PLUS ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv111 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv109 * _menhir_state * 'tv_term) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState11
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState11
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState11
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState11
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState11
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState11) : 'freshtv110)) : 'freshtv112)
        | AND | EOL | EQUAL | LEQ | P | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv113 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, t) = _menhir_stack in
            let _v : 'tv_bexp = 
# 49 "parserAssumptions.mly"
         (t)
# 1172 "parserAssumptions.ml"
             in
            _menhir_goto_bexp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv114)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv115 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv116)) : 'freshtv118)) : 'freshtv120)
    | MenhirState13 | MenhirState11 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv131 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv129 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | PLUS ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv123 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv121 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | B ->
                _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState13
            | LPAREN ->
                _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState13
            | NOT ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState13
            | ONE ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState13
            | ZERO ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState13
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState13) : 'freshtv122)) : 'freshtv124)
        | AND | EOL | EQUAL | LEQ | P | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv125 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, t) = _menhir_stack in
            let _v : 'tv_plus = 
# 53 "parserAssumptions.mly"
         ([t])
# 1220 "parserAssumptions.ml"
             in
            _menhir_goto_plus _menhir_env _menhir_stack _menhir_s _v) : 'freshtv126)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv127 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv128)) : 'freshtv130)) : 'freshtv132)
    | _ ->
        _menhir_fail ()

and _menhir_goto_symb : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_symb -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState62 | MenhirState59 | MenhirState56 | MenhirState52 | MenhirState42 | MenhirState49 | MenhirState43 | MenhirState45 | MenhirState0 | MenhirState31 | MenhirState3 | MenhirState28 | MenhirState6 | MenhirState7 | MenhirState11 | MenhirState13 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv101 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv99 * _menhir_state * 'tv_symb) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState14
        | LPAREN ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState14
        | NOT ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState14
        | ONE ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState14
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState14
        | AND | EOL | EQUAL | LEQ | P | PLUS | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv97 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, s) = _menhir_stack in
            let _v : 'tv_term = 
# 57 "parserAssumptions.mly"
         (s)
# 1263 "parserAssumptions.ml"
             in
            _menhir_goto_term _menhir_env _menhir_stack _menhir_s _v) : 'freshtv98)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState14) : 'freshtv100)) : 'freshtv102)
    | MenhirState15 | MenhirState14 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv107 * _menhir_state * 'tv_symb) * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv105 * _menhir_state * 'tv_symb) * _menhir_state * 'tv_symb) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | LPAREN ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | NOT ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | ONE ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | AND | EOL | EQUAL | LEQ | P | PLUS | RPAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv103 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, s) = _menhir_stack in
            let _v : 'tv_concat = 
# 61 "parserAssumptions.mly"
         ([s])
# 1296 "parserAssumptions.ml"
             in
            _menhir_goto_concat _menhir_env _menhir_stack _menhir_s _v) : 'freshtv104)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState15) : 'freshtv106)) : 'freshtv108)

and _menhir_discard : _menhir_env -> token =
  fun _menhir_env ->
    let lexbuf = _menhir_env._menhir_lexbuf in
    let _tok = _menhir_env._menhir_lexer lexbuf in
    _menhir_env._menhir_token <- _tok;
    _menhir_env._menhir_startp <- lexbuf.Lexing.lex_start_p;
    _menhir_env._menhir_endp <- lexbuf.Lexing.lex_curr_p;
    let shifted = Pervasives.(+) _menhir_env._menhir_shifted 1 in
    if Pervasives.(>=) shifted 0 then
      _menhir_env._menhir_shifted <- shifted;
    _tok

and _menhir_errorcase : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    match _menhir_s with
    | MenhirState62 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv61 * _menhir_state * 'tv_axiomEq) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv62)
    | MenhirState59 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv63 * _menhir_state * 'tv_axiomLeq) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv64)
    | MenhirState56 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv65 * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv66)
    | MenhirState52 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv67 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1339 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv68)
    | MenhirState49 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv69 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1348 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1352 "parserAssumptions.ml"
        )) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv70)
    | MenhirState45 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv71 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1361 "parserAssumptions.ml"
        )) * _menhir_state) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1365 "parserAssumptions.ml"
        )) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv72)
    | MenhirState43 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv73 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1374 "parserAssumptions.ml"
        )) * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv74)
    | MenhirState42 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv75 * _menhir_state * 'tv_bexp) * (
# 12 "parserAssumptions.mly"
       (int)
# 1383 "parserAssumptions.ml"
        )) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv76)
    | MenhirState31 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv77 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1392 "parserAssumptions.ml"
        )) * _menhir_state * 'tv_bexp) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv78)
    | MenhirState28 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv79 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1401 "parserAssumptions.ml"
        )) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1405 "parserAssumptions.ml"
        )) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv80)
    | MenhirState15 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv81 * _menhir_state * 'tv_symb) * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv82)
    | MenhirState14 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv83 * _menhir_state * 'tv_symb) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv84)
    | MenhirState13 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv85 * _menhir_state * 'tv_term) * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv86)
    | MenhirState11 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv87 * _menhir_state * 'tv_term) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv88)
    | MenhirState7 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv89 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv90)
    | MenhirState6 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv91 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv92)
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv93 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1444 "parserAssumptions.ml"
        )) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv94)
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv95) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv96)

and _menhir_run1 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _ = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv59) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    ((let _v : 'tv_symb = 
# 65 "parserAssumptions.mly"
       (MKE.Zero)
# 1462 "parserAssumptions.ml"
     in
    _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv60)

and _menhir_run2 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv57 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | INT _v ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv53 * _menhir_state) = Obj.magic _menhir_stack in
        let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 1480 "parserAssumptions.ml"
        )) = _v in
        ((let _menhir_stack = (_menhir_stack, _v) in
        let _tok = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv51 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1488 "parserAssumptions.ml"
        )) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState3
        | EQUAL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv49 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1499 "parserAssumptions.ml"
            )) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = MenhirState3 in
            ((let _menhir_stack = (_menhir_stack, _menhir_s) in
            let _tok = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv47 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1508 "parserAssumptions.ml"
            )) * _menhir_state) = _menhir_stack in
            let (_tok : token) = _tok in
            ((match _tok with
            | P ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv43 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1517 "parserAssumptions.ml"
                )) * _menhir_state) = Obj.magic _menhir_stack in
                ((let _tok = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv41 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1524 "parserAssumptions.ml"
                )) * _menhir_state) = _menhir_stack in
                let (_tok : token) = _tok in
                ((match _tok with
                | INT _v ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : (('freshtv37 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1533 "parserAssumptions.ml"
                    )) * _menhir_state) = Obj.magic _menhir_stack in
                    let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 1538 "parserAssumptions.ml"
                    )) = _v in
                    ((let _menhir_stack = (_menhir_stack, _v) in
                    let _tok = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv35 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1546 "parserAssumptions.ml"
                    )) * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1550 "parserAssumptions.ml"
                    )) = _menhir_stack in
                    let (_tok : token) = _tok in
                    ((match _tok with
                    | B ->
                        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState28
                    | LPAREN ->
                        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState28
                    | NOT ->
                        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState28
                    | ONE ->
                        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState28
                    | ZERO ->
                        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState28
                    | _ ->
                        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                        _menhir_env._menhir_shifted <- (-1);
                        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState28) : 'freshtv36)) : 'freshtv38)
                | _ ->
                    assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                    _menhir_env._menhir_shifted <- (-1);
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : (('freshtv39 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1575 "parserAssumptions.ml"
                    )) * _menhir_state) = Obj.magic _menhir_stack in
                    ((let (_menhir_stack, _menhir_s) = _menhir_stack in
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv40)) : 'freshtv42)) : 'freshtv44)
            | _ ->
                assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
                _menhir_env._menhir_shifted <- (-1);
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv45 * _menhir_state) * (
# 12 "parserAssumptions.mly"
       (int)
# 1586 "parserAssumptions.ml"
                )) * _menhir_state) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv46)) : 'freshtv48)) : 'freshtv50)
        | LPAREN ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState3
        | NOT ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState3
        | ONE ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState3
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState3
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState3) : 'freshtv52)) : 'freshtv54)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv55 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv56)) : 'freshtv58)

and _menhir_run4 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _ = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv33) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    ((let _v : 'tv_symb = 
# 64 "parserAssumptions.mly"
      (MKE.One)
# 1619 "parserAssumptions.ml"
     in
    _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv34)

and _menhir_run5 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv31 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv23 * _menhir_state) = Obj.magic _menhir_stack in
        ((let _tok = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv21 * _menhir_state) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | INT _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv17 * _menhir_state) = Obj.magic _menhir_stack in
            let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 1645 "parserAssumptions.ml"
            )) = _v in
            ((let _ = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv15 * _menhir_state) = Obj.magic _menhir_stack in
            let (i : (
# 12 "parserAssumptions.mly"
       (int)
# 1653 "parserAssumptions.ml"
            )) = _v in
            ((let (_menhir_stack, _menhir_s) = _menhir_stack in
            let _v : 'tv_symb = 
# 67 "parserAssumptions.mly"
                  (MKE.(NegBexp (Test i)))
# 1659 "parserAssumptions.ml"
             in
            _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv16)) : 'freshtv18)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv19 * _menhir_state) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv20)) : 'freshtv22)) : 'freshtv24)
    | LPAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv27 * _menhir_state) = Obj.magic _menhir_stack in
        ((let _tok = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv25 * _menhir_state) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState6
        | LPAREN ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState6
        | NOT ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState6
        | ONE ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState6
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState6
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState6) : 'freshtv26)) : 'freshtv28)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv29 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv30)) : 'freshtv32)

and _menhir_run7 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv13 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState7
    | LPAREN ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState7
    | NOT ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState7
    | ONE ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState7
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState7
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState7) : 'freshtv14)

and _menhir_run8 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv11 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | INT _v ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv7 * _menhir_state) = Obj.magic _menhir_stack in
        let (_v : (
# 12 "parserAssumptions.mly"
       (int)
# 1736 "parserAssumptions.ml"
        )) = _v in
        ((let _ = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv5 * _menhir_state) = Obj.magic _menhir_stack in
        let (i : (
# 12 "parserAssumptions.mly"
       (int)
# 1744 "parserAssumptions.ml"
        )) = _v in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        let _v : 'tv_symb = 
# 66 "parserAssumptions.mly"
            (MKE.(Test i))
# 1750 "parserAssumptions.ml"
         in
        _menhir_goto_symb _menhir_env _menhir_stack _menhir_s _v) : 'freshtv6)) : 'freshtv8)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv9 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv10)) : 'freshtv12)

and data : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (
# 23 "parserAssumptions.mly"
      ( ( ((int * (MKE.be * MKE.be)) list) * ((MKE.be * MKE.be) list) ))
# 1764 "parserAssumptions.ml"
) =
  fun lexer lexbuf ->
    let _menhir_env =
      let (lexer : Lexing.lexbuf -> token) = lexer in
      let (lexbuf : Lexing.lexbuf) = lexbuf in
      ((let _tok = lexer lexbuf in
      {
        _menhir_lexer = lexer;
        _menhir_lexbuf = lexbuf;
        _menhir_token = _tok;
        _menhir_startp = lexbuf.Lexing.lex_start_p;
        _menhir_endp = lexbuf.Lexing.lex_curr_p;
        _menhir_shifted = 1073741823;
        }) : _menhir_env)
    in
    Obj.magic (let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv3) = () in
    ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
    let _tok = _menhir_env._menhir_token in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv1) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | LPAREN ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | NOT ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | ONE ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | P ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState0) : 'freshtv2)) : 'freshtv4))



